VERSION 5.00
Begin VB.Form Form1 
   AutoRedraw      =   -1  'True
   BackColor       =   &H00008000&
   BorderStyle     =   3  'Fester Dialog
   Caption         =   "Graslandschaft"
   ClientHeight    =   7860
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   10470
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   7860
   ScaleWidth      =   10470
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows-Standard
   Begin VB.PictureBox picGrass 
      Height          =   255
      Left            =   480
      Picture         =   "Form1.frx":0000
      ScaleHeight     =   195
      ScaleWidth      =   195
      TabIndex        =   0
      Top             =   1440
      Visible         =   0   'False
      Width           =   255
   End
   Begin VB.Timer tmrMotion 
      Interval        =   5
      Left            =   360
      Top             =   480
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Const Size     As Long = 100     ' Skalierungsgre
Private Const Speed    As Single = 200 ' Bewegungsgeschwindigkeit
Private Const NumGrass As Long = 50      ' Zahl der Grser pro Quadrant

' Position
Private X As Single, Y As Single

' Bewegungsgeschwindigkeit pro Tick
Dim v As Single

' Tasten abfragen
Private Declare Function GetAsyncKeyState Lib "user32" (ByVal vKey As Long) As Integer

' Gebiet rendern
Private Sub Render()
   Dim quadX As Long, quadY As Long
   Dim i As Long, j As Long, k As Long
   
   ' Quadranten ermitteln
   quadX = IIf(X >= 0, (X \ Size) + 1, -(Abs(X) \ Size) - 1)
   quadY = IIf(Y >= 0, (Y \ Size) + 1, -(Abs(Y) \ Size) - 1)
   
   ' Bildflche lschen
   Call Cls
   
   ' Die 9 umgebenden Quadranten abfahren, die gesehen werden knnten
   For i = quadX - 1 To quadX + 1
      For j = quadY - 1 To quadY + 1
      
         ' Eindeutigen Indexwert fr den aktuellen Quadranten ausrechnen
         Dim n As Long: n = 0.5 * (i + j) * (i + j + 1) + j
      
         ' Zufallsgenerator damit initialisieren
         Call Rnd(-1)
         Call Randomize(n)

         ' Grser dort "zufllig" zeichnen
         For k = 1 To NumGrass
            Call PaintPicture(picGrass.Image, i * Size + (Rnd * Size) - X, j * Size + (Rnd * Size) - Y)
         Next k
         
      Next j
   Next i
End Sub

' Zustand updaten
Private Sub tmrMotion_Timer()

   ' Pfeiltasten fr Bewegung abfragen, ggf. neue Position berechnen
   If GetAsyncKeyState(37) <> 0 Then X = X - v
   If GetAsyncKeyState(38) <> 0 Then Y = Y + v
   If GetAsyncKeyState(39) <> 0 Then X = X + v
   If GetAsyncKeyState(40) <> 0 Then Y = Y - v
   
   ' Neu zeichnen
   Call Render
End Sub

' Voreinstellungen treffen
Private Sub Form_Load()
   Scale (0, Size)-(Size, 0)
   v = Speed * (tmrMotion.Interval / 1000)
End Sub
